SHELL         := /bin/bash
UNAME_S       := $(shell uname -s)
CURR_BRANCH   := $(shell git rev-parse --abbrev-ref HEAD)
DEPLOY_BRANCH := master
ifeq ($(UNAME_S),Darwin)
VENVW         := $(shell which virtualenvwrapper.sh)
else
VENVW         := /usr/share/virtualenvwrapper/virtualenvwrapper.sh
endif

ifeq ($(UNAME_S),Darwin)
.PHONY: macos_install
macos_install:
	brew install python3
	pip3 install virtualenv virtualenvwrapper
	@touch ~/.bashrc
	@touch ~/.bash_profile
	@grep -qF '.bashrc' ~/.bash_profile || echo '[ -r ~/.bashrc ] && source ~/.bashrc' >> ~/.bash_profile
	@grep -qF 'VIRTUALENVWRAPPER_PYTHON' ~/.bashrc || echo 'export VIRTUALENVWRAPPER_PYTHON=/usr/local/bin/python3' >> ~/.bashrc
	@grep -qF '/usr/local/bin/virtualenvwrapper.sh' ~/.bashrc || echo 'source /usr/local/bin/virtualenvwrapper.sh' >> ~/.bashrc

.PHONY: macos_setup
macos_setup: macos_install
	@source ~/.bashrc; \
	source $(VENVW); \
	lsvirtualenv  | grep -x link-docs ||  mkvirtualenv -r requirements.txt  link-docs
	echo
	echo "Setup complete. To view the docs, run:  make serve"
endif
	
.PHONY: update
update:
	@source $(VENVW); \
	workon link-docs; \
	pip install --upgrade -r requirements.txt; \
	echo "Python environment is up to date"
	

.PHONY: serve
serve:
	@source $(VENVW); \
	workon link-docs; \
	mkdocs serve

